package com.engine.organization.web;

import com.engine.common.util.ServiceUtil;
import com.engine.organization.util.response.ReturnResult;
import com.engine.organization.wrapper.FieldDefinedWrapper;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

/**
 * @Author weaver_cl
 * @description:
 * @Date 2022/6/13
 * @Version V1.0
 **/
public class FieldDefinedController {

    private FieldDefinedWrapper getFieldDefinedWrapper(User user) {
        return ServiceUtil.getService(FieldDefinedWrapper.class,user);
    }

    @GET
    @Path("/{moduleName}/getTree")
    @Produces(MediaType.APPLICATION_JSON)
    public ReturnResult getHasRight(@Context HttpServletRequest request, @Context HttpServletResponse response,
                                    @PathParam("moduleName") String moduleName) {
        try {
            User user = HrmUserVarify.getUser(request, response);
            return ReturnResult.successed(getFieldDefinedWrapper(user).getTree(moduleName));
        } catch (Exception e) {
            return ReturnResult.exceptionHandle(e.getMessage());
        }
    }
}
